/*
** strings.js
*/

var glbNewContactString = "New Contact";
var glbConnectedString = "Connected";
var glbDisconnectedString = "Disconnected";
var glbNotConnectedString = "Not Connected";
var glbConnectingString = "Connecting...";
var glbEditName = "Edit Name";
var glbEditNumber = "Edit Number";
var glbDblClickDelContact = "Double Click to Delete Contact";
var glbAcceptString = "Accept";
var glbHangupString = "HangUp";
var glbActiveCallsString = "Still Active Calls";
var glbSelectString = "Select";
var glbOutgoing = "Outgoing";
var glbIncoming = "Incoming";
var glbDefaultUser = "user";
var glbDefaultPassword = "pwd";

function getLanguage() {
    var code = "en";

// Android browser return always English as language, even when your phone is set up with a different one. Because of
// that, we read here the user agent and we extract from there the phone language. For all the other devices,
// "navigator.language" should give as the correct language.
    var ua = navigator.userAgent.toLowerCase();
    var isAndroid = ua.indexOf("android") > -1;
    var found = false;

    if(isAndroid) {
        if (ua.indexOf("en-") > -1) {
            code = "en";
        } else if (ua.indexOf("fr-") > -1) {
            code = "fr";
        } else if (ua.indexOf("de-") > -1) {
            code = "de";
        } else if (ua.indexOf("it-") > -1) {
            code = "it";
        } else if (ua.indexOf("es-") > -1) {
            code = "es";
        } else if (ua.indexOf("pt-") > -1) {
            code = "pt";
        } else {
            code = navigator.language;
            code = code.substr(0, 2);
        }

        found = true;
    }

    if ((!found) && (navigator)) {
        if (navigator.language) {
            code = navigator.language;
        } else if (navigator.browserLanguage) {
            code = navigator.browserLanguage;
        } else if (navigator.systemLanguage) {
            code = navigator.systemLanguage;
        } else if (navigator.userLanguage) {
            code = navigator.userLanguage;
        }
        code = code.substr(0, 2);
    }

    if (code == "fr") {
        lang = "french";
    } else if (code == "de") {
        lang = "german";
    } else if (code == "it") {
        lang = "italian";
    } else if (code == "es") {
        lang = "spanish";
    } else if (code == "pt") {
        lang = "portuguese";
    } else {
        lang = "english";
    }

    return lang;
}

function setLanguageStrings(language) {
    var nav_contacts;
    var nav_phone;
    var nav_calls;
    var container_contacts;
    var add_contact;
    var phone_call;
    var phone_hangup;
    var settings_sound;
    var settings_string;
    var settings_micro;
    var calls_string;
    var general_string;
    var settings_domain;
    var settings_account;
    var settings_secret;
    var settings_connect;
    var calls_log;
    var clear_calls_log;
    var debug_string;
    var show_log;
    var force_number;
    var rule_force_number;
    var ip_or_hostname;

    if (language == "french") {
        nav_contacts =                    "Contacts";
        nav_phone =                       "Téléphone";
        nav_calls =                       "Appels";
        container_contacts =              "Contacts";
        add_contact =                     "Ajouter Contact";
        phone_call =                      "Appel";
        phone_hangup =                    "Fin";
        settings_sound =                  "Son";
        settings_string =                 "Paramètres";
        settings_micro =                  "Micro";
        calls_string =                    "Appels";
        general_string =                  "Général";
        settings_domain =                 "Domaine";
        settings_account =                "Identifiant";
        settings_secret =                 "Mot de Passe";
        settings_connect =                "Connexion";
        calls_log =                       "Journal des Appels";
        clear_calls_log =                 "Effacer le Journal";
        debug_string =                    "Déboguer";
        show_log =                        "Montrer le Journal";
        force_number =                    "Forcer un Numéro";
        rule_force_number =               "Forcer un numéro qui va être composé pour tous les appels sortants.";
        ip_or_hostname =                  "IP ou Nom d'Hôte";

        glbNewContactString =             "Nouveau Contact";
        glbConnectedString =              "Connecté";
        glbDisconnectedString =           "Déconnecté";
        glbNotConnectedString =           "Non Connecté";
        glbConnectingString =             "Connexion en Cours...";
        glbEditName =                     "Editer Nom";
        glbEditNumber =                   "Editer Numéro";
        glbDblClickDelContact=            "Double Cliquez pour Supprimer le Contact";
        glbAcceptString =                 "Accepter";
        glbHangupString =                 "Couper";
        glbActiveCallsString =            "Encore des Appels Actifs";
        glbSelectString =                 "Choisir";
        glbOutgoing =                     "Sortant";
        glbIncoming =                     "Entrant";
        glbDefaultUser =                  "utilisateur";
        glbDefaultPassword =              "mdp";
    } else {
        nav_contacts =                    "Contacts";
        nav_phone =                       "Phone";
        nav_calls =                       "Calls";
        container_contacts =              "Contacts";
        add_contact =                     "Add Contact";
        phone_call =                      "Call";
        phone_hangup =                    "End";
        settings_sound =                  "Sound";
        settings_string =                 "Settings";
        settings_micro =                  "Micro";
        calls_string =                    "Calls";
        general_string =                  "General";
        settings_domain =                 "Domain";
        settings_account =                "Account";
        settings_secret =                 "Secret";
        settings_connect =                "Connection";
        calls_log =                       "Calls Log";
        clear_calls_log =                 "Clear Calls Log";
        debug_string =                    "Debug";
        show_log =                        "Show Log";
        force_number =                    "Force Number";
        rule_force_number =               "Set a number which will be dialed for all outgoing calls.";
        ip_or_hostname =                  "IP or Hostname";

        glbNewContactString =             "New Contact";
        glbConnectedString =              "Connected";
        glbDisconnectedString =           "Disconnected";
        glbNotConnectedString =           "Not Connected";
        glbConnectingString =             "Connecting...";
        glbEditName =                     "Edit Name";
        glbEditNumber =                   "Edit Number";
        glbDblClickDelContact=            "Double Click to Delete Contact";
        glbAcceptString =                 "Accept";
        glbHangupString =                 "HangUp";
        glbActiveCallsString =            "Still Active Calls";
        glbSelectString =                 "Select";
        glbOutgoing =                     "Outgoing";
        glbIncoming =                     "Incoming";
        glbDefaultUser =                  "user";
        glbDefaultPassword =              "pwd";
    }

    document.getElementById("nav_contacts").innerHTML = nav_contacts;
    document.getElementById("nav_phone").innerHTML = nav_phone;
    document.getElementById("nav_calls").innerHTML = nav_calls;
    document.getElementById("addNumber").innerHTML = add_contact;
    document.getElementById("buttonHangUpAll").innerHTML = phone_hangup;
    document.getElementById("buttonCallGreen").innerHTML = phone_call;
    document.getElementById("buttonCallYellow").innerHTML = phone_call;
    document.getElementById("buttonCallWhite").innerHTML = phone_call;
    document.getElementById("settings_sound").innerHTML = settings_sound;
    document.getElementById("settings_string").innerHTML = settings_string;
    document.getElementById("settings_micro").innerHTML = settings_micro;
    document.getElementById("calls_string").innerHTML = calls_string;
    document.getElementById('settingsDialog').setAttribute("title", settings_string);
    document.getElementById("general_string").innerHTML = general_string;
    document.getElementById("settings-domain").innerHTML = settings_domain;
    document.getElementById("settings-sipaccount").innerHTML = settings_account;
    document.getElementById("settings-sipsecret").innerHTML = settings_secret;
    document.getElementById("settingsConnect").innerHTML = settings_connect;
    document.getElementById("calls_log").innerHTML = calls_log;
    document.getElementById("settingsClearCalllog").innerHTML = clear_calls_log;
    document.getElementById("debug_string").innerHTML = debug_string;
    document.getElementById("show_log").innerHTML = show_log;
    document.getElementById("settings-forcenumber").innerHTML = force_number;
    document.getElementById("rule-forcenumber").innerHTML = rule_force_number;
    document.getElementById('settings-host').setAttribute("placeholder", ip_or_hostname);
}
